#!/usr/bin/perl
# ipdb/cgi-bin/newnode.cgi
# Add new wifi tower or fibre demarc switch ("node") to database
###
# SVN revision info
# $Date: 2012-10-18 20:53:10 +0000 (Thu, 18 Oct 2012) $
# SVN revision $Rev: 517 $
# Last update by $Author: kdeugau $
###
# Copyright (C) 2010 - Kris Deugau

use strict;
use warnings;
#use CGI::Carp qw(fatalsToBrowser);
use CGI::Simple;
use HTML::Template;
use DBI;
#use POSIX qw(ceil);
use NetAddr::IP;
use Sys::Syslog;

# don't remove!  required for GNU/FHS-ish install from tarball
##uselib##

use MyIPDB;

openlog "IPDB","pid","$IPDB::syslog_facility";

# Collect the username from HTTP auth.  If undefined, we're in a test environment.
my $authuser;
if (!defined($ENV{'REMOTE_USER'})) {
  $authuser = '__temptest';
} else {
  $authuser = $ENV{'REMOTE_USER'};
}

# Set up the CGI object...
my $q = new CGI::Simple;
# ... and get query-string params as well as POST params if necessary
$q->parse_query_string;

# Convenience;  saves changing all references to %webvar
##fixme:  tweak for handling <select multiple='y' size=3> (list with multiple selection)
my %webvar = $q->Vars;

my ($dbh,$errstr) = connectDB_My;
my $sth;

$ENV{HTML_TEMPLATE_ROOT} = '../templates';

my $page = HTML::Template->new(filename => "newnode.tmpl");

if ($webvar{nodename}) {
  $sth = $dbh->prepare("insert into nodes (node_type,node_name,node_ip) values (?,?,?)");
  $sth->execute($webvar{type}, $webvar{nodename}, $webvar{nodeip});
  $page->param(nodename => $webvar{nodename});
  if ($sth->err) {
    $page->param(err => $sth->errstr);
    my $msg = "$authuser could not add node '$webvar{nodename}','$webvar{type}' to database: ".$sth->errstr;
    mailNotify($dbh, 'f:nno', "IPDB node add failure", $msg);
    syslog "err", $msg;
  } else {
    syslog "notice", "$authuser added node '$webvar{nodename}'";
  }
}

print "Content-type: text/html\n\n";

print $page->output;

finish($dbh);
